"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .address import Address, AddressTypedDict
from .birthdate import BirthDate, BirthDateTypedDict
from .governmentid import GovernmentID, GovernmentIDTypedDict
from .individualname import IndividualName, IndividualNameTypedDict
from .phonenumber import PhoneNumber, PhoneNumberTypedDict
from .representativeresponsibilities import (
    RepresentativeResponsibilities,
    RepresentativeResponsibilitiesTypedDict,
)
from moovio_sdk.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CreateRepresentativeTypedDict(TypedDict):
    r"""Describes a business representative to create."""

    name: IndividualNameTypedDict
    phone: NotRequired[PhoneNumberTypedDict]
    email: NotRequired[str]
    address: NotRequired[AddressTypedDict]
    birth_date: NotRequired[BirthDateTypedDict]
    government_id: NotRequired[GovernmentIDTypedDict]
    responsibilities: NotRequired[RepresentativeResponsibilitiesTypedDict]
    r"""Describes the job responsibilities of a business representative."""


class CreateRepresentative(BaseModel):
    r"""Describes a business representative to create."""

    name: IndividualName

    phone: Optional[PhoneNumber] = None

    email: Optional[str] = None

    address: Optional[Address] = None

    birth_date: Annotated[Optional[BirthDate], pydantic.Field(alias="birthDate")] = None

    government_id: Annotated[
        Optional[GovernmentID], pydantic.Field(alias="governmentID")
    ] = None

    responsibilities: Optional[RepresentativeResponsibilities] = None
    r"""Describes the job responsibilities of a business representative."""
